﻿//****************************************************************************
// Copyright (c) Microsoft Corporation. All rights reserved.
//****************************************************************************
using System;
using System.Configuration;
using System.Web.Configuration;
using System.Diagnostics.CodeAnalysis;

using Microsoft.FxCop.Sdk;

namespace Microsoft.FxCop.Rules.ASP.Security.Configuration
{
    sealed class CustomErrorPageShouldBeSpecified : SystemWebConfigurationIntrospectionRule
    {
        #region *** Constructor ***
        public CustomErrorPageShouldBeSpecified()
            : base(typeof(CustomErrorPageShouldBeSpecified).Name)
        {
        }
        #endregion

        #region *** SystemWebConfigurationIntrospectionRule ***

        protected override ProblemCollection Check(SystemWebSectionGroup webConfig)
        {
            if (webConfig == null)
                throw (new ArgumentNullException("webConfig"));

            if (webConfig.CustomErrors.Mode != CustomErrorsMode.Off)
            {
                if (string.IsNullOrEmpty(webConfig.CustomErrors.DefaultRedirect))
                    AddProblem(webConfig.CustomErrors.ElementInformation);
            }

            return base.Problems;
        }

        #endregion
    }
}
