﻿//****************************************************************************
// Copyright (c) Microsoft Corporation. All rights reserved.
//****************************************************************************
using System;
using System.Configuration;
using System.Web.Configuration;
using System.Diagnostics.CodeAnalysis;
using Microsoft.FxCop.Sdk;

namespace Microsoft.FxCop.Rules.ASP.Security.Configuration
{
    sealed class EnableCrossAppRedirectsShouldBeTrue : SystemWebConfigurationIntrospectionRule
    {
        #region *** Constructor ***
        public EnableCrossAppRedirectsShouldBeTrue()
            : base(typeof(EnableCrossAppRedirectsShouldBeTrue).Name)
        {
        }
        #endregion

        #region *** SystemWebConfigurationIntrospectionRule ***
        protected override ProblemCollection Check(SystemWebSectionGroup webConfig)
        {
            if (webConfig == null)
                throw (new ArgumentNullException("webConfig"));

            if (webConfig.Authentication.Mode == AuthenticationMode.Forms)
            {
                if (webConfig.Authentication.Forms.EnableCrossAppRedirects)
                    AddProblem(webConfig.Authentication.Forms.ElementInformation);
            }

            return base.Problems;
        }
        #endregion
    }
}
