﻿//****************************************************************************
// Copyright (c) Microsoft Corporation. All rights reserved.
//****************************************************************************
using System;
using System.Configuration;
using System.Web.Configuration;
using System.Diagnostics.CodeAnalysis;

using Microsoft.FxCop.Sdk;

namespace Microsoft.FxCop.Rules.ASP.Security.Configuration
{
    sealed class FormAuthenticationRequireSSLShouldBeTrue : SystemWebConfigurationIntrospectionRule
    {
        #region *** Constructor ***
        public FormAuthenticationRequireSSLShouldBeTrue()
            : base(typeof(FormAuthenticationRequireSSLShouldBeTrue).Name)
        {
        }
        #endregion

        #region *** SystemWebConfigurationIntrospectionRule ***
        protected override ProblemCollection Check(SystemWebSectionGroup webConfig)
        {
            if (webConfig == null)
                throw (new ArgumentNullException("webConfig"));

            if (webConfig.Authentication.Mode == AuthenticationMode.Forms)
            {
                if (!webConfig.Authentication.Forms.RequireSSL)
                {
                    AddProblem(webConfig.Authentication.Forms.ElementInformation);
                }
            }

            return base.Problems;
        }
        #endregion
    }
}
