﻿//****************************************************************************
// Copyright (c) Microsoft Corporation. All rights reserved.
//****************************************************************************
using System;
using System.Configuration;
using System.Web.Configuration;
using System.Diagnostics.CodeAnalysis;
using Microsoft.FxCop.Sdk;

namespace Microsoft.FxCop.Rules.ASP.Security.Configuration
{
    sealed class FormAuthenticationSlidingExpirationShouldBeFalse : SystemWebConfigurationIntrospectionRule
    {
        #region *** Constructor ***
        public FormAuthenticationSlidingExpirationShouldBeFalse()
            : base(typeof(FormAuthenticationSlidingExpirationShouldBeFalse).Name)
        {
        }
        #endregion

        #region *** SystemWebConfigurationIntrospectionRule ***
        protected override ProblemCollection Check(SystemWebSectionGroup webConfig)
        {
            if (webConfig == null)
                throw (new ArgumentNullException("webConfig"));

            if (webConfig.Authentication.Mode == AuthenticationMode.Forms)
            {
                if (!webConfig.Authentication.Forms.RequireSSL)
                {
                    if (webConfig.Authentication.Forms.SlidingExpiration)
                        AddProblem(webConfig.Authentication.Forms.ElementInformation);
                }
            }

            return base.Problems;
        }
        #endregion
    }
}
