//****************************************************************************
// Copyright (c) Microsoft Corporation. All rights reserved.
//****************************************************************************
using System;
using System.Configuration;
using System.Web.Configuration;
using System.Diagnostics.CodeAnalysis;
using Microsoft.FxCop.Sdk;

namespace Microsoft.FxCop.Rules.ASP.Security.Configuration
{
    sealed class HttpCookiesHttpOnlyCookiesShouldBeTrue : SystemWebConfigurationIntrospectionRule
    {
        #region *** Constructor ***
        public HttpCookiesHttpOnlyCookiesShouldBeTrue()
            : base(typeof(HttpCookiesHttpOnlyCookiesShouldBeTrue).Name)
        {
        }
        #endregion

        #region *** SystemWebConfigurationIntrospectionRule ***
        protected override ProblemCollection Check(SystemWebSectionGroup webConfig)
        {
            if (webConfig == null)
                throw (new ArgumentNullException("webConfig"));

            if (!webConfig.HttpCookies.HttpOnlyCookies)
                AddProblem(webConfig.HttpCookies.ElementInformation);

            return base.Problems;
        }
        #endregion
    }
}