//****************************************************************************
// Copyright (c) Microsoft Corporation. All rights reserved.
//****************************************************************************
using System;
using System.Configuration;
using System.Web.Configuration;
using System.Diagnostics.CodeAnalysis;

using Microsoft.FxCop.Sdk;

namespace Microsoft.FxCop.Rules.ASP.Security.Configuration
{
    sealed class HttpCookiesRequireSSLShouldBeTrue : SystemWebConfigurationIntrospectionRule
    {

        #region *** Constructor ***
        public HttpCookiesRequireSSLShouldBeTrue()
            : base(typeof(HttpCookiesRequireSSLShouldBeTrue).Name)
        {
        }
        #endregion

        #region *** SystemWebConfigurationIntrospectionRule ***
        protected override ProblemCollection Check(SystemWebSectionGroup webConfig)
        {
            if (webConfig == null)
                throw (new ArgumentNullException("webConfig"));

            if (!webConfig.HttpCookies.RequireSSL)
                AddProblem(webConfig.HttpCookies.ElementInformation);

            return base.Problems;
        }
        #endregion
    }
}
