﻿//****************************************************************************
// Copyright (c) Microsoft Corporation. All rights reserved.
//****************************************************************************
using System;
using System.Configuration;
using System.Web.Configuration;
using System.Diagnostics.CodeAnalysis;

using Microsoft.FxCop.Sdk;

namespace Microsoft.FxCop.Rules.ASP.Security.Configuration
{
    sealed class PagesEnableEventValidationMustBeTrue : SystemWebConfigurationIntrospectionRule
    {
        #region *** Constructor ***
        public PagesEnableEventValidationMustBeTrue()
            : base(typeof(PagesEnableEventValidationMustBeTrue).Name)
        {
        }
        #endregion

        #region *** SystemWebConfigurationIntrospectionRule ***
        protected override ProblemCollection Check(SystemWebSectionGroup webConfig)
        {
            if (webConfig == null)
                throw (new ArgumentNullException("webConfig"));

            if( !webConfig.Pages.EnableEventValidation )
                AddProblem(webConfig.Pages.ElementInformation);

            return base.Problems;
        }

        #endregion
    }
}

