﻿//****************************************************************************
// Copyright (c) Microsoft Corporation. All rights reserved.
//****************************************************************************
using System;
using System.Configuration;
using System.Web.Configuration;
using System.Diagnostics.CodeAnalysis;

using Microsoft.FxCop.Sdk;

namespace Microsoft.FxCop.Rules.ASP.Security.Configuration
{
    sealed class PagesValidateRequestShouldBeEnabled : SystemWebConfigurationIntrospectionRule
    {
        #region *** Constructor ***
        public PagesValidateRequestShouldBeEnabled()
            : base(typeof(PagesValidateRequestShouldBeEnabled).Name)
        {
        }
        #endregion

        #region *** SystemWebConfigurationIntrospectionRule ***
        protected override ProblemCollection Check(SystemWebSectionGroup webConfig)
        {
            if (webConfig == null)
                throw (new ArgumentNullException("webConfig"));

            // http://msdn.microsoft.com/en-us/library/950xf363.aspx
            if (!webConfig.Pages.ValidateRequest)
                AddProblem(webConfig.Pages.ElementInformation);

            return base.Problems;
        }
        #endregion
    }
}