﻿//****************************************************************************
// Copyright (c) Microsoft Corporation. All rights reserved.
//****************************************************************************
using System;
using System.Configuration;
using System.Web.Configuration;
using System.Diagnostics.CodeAnalysis;

using Microsoft.FxCop.Sdk;

namespace Microsoft.FxCop.Rules.ASP.Security.Configuration
{
    sealed class PagesViewStateEncryptionModeShouldBeAlways : SystemWebConfigurationIntrospectionRule
    {
        #region *** Constructor ***
        public PagesViewStateEncryptionModeShouldBeAlways()
            : base(typeof(PagesViewStateEncryptionModeShouldBeAlways).Name)
        {
        }
        #endregion

        #region *** SystemWebConfigurationIntrospectionRule ***
        protected override ProblemCollection Check(SystemWebSectionGroup webConfig)
        {
            if (webConfig == null)
                throw (new ArgumentNullException("webConfig"));

            switch (webConfig.Pages.ViewStateEncryptionMode)
            {
                case System.Web.UI.ViewStateEncryptionMode.Never:
                case System.Web.UI.ViewStateEncryptionMode.Auto:
                    AddProblem(webConfig.Pages.ElementInformation);
                    break;
            }
                

            return base.Problems;
        }
        #endregion
    }
}