﻿//****************************************************************************
// Copyright (c) Microsoft Corporation. All rights reserved.
//****************************************************************************
using System;
using System.Configuration;
using System.Web.Configuration;
using System.Web.Security;
using System.Diagnostics.CodeAnalysis;

using Microsoft.FxCop.Sdk;

namespace Microsoft.FxCop.Rules.ASP.Security.Configuration
{
    sealed class RoleManagerCookieProtectionShouldBeAll : SystemWebConfigurationIntrospectionRule
    {

        #region *** Constructor ***
        public RoleManagerCookieProtectionShouldBeAll()
            : base(typeof(RoleManagerCookieProtectionShouldBeAll).Name)
        {
        }
        #endregion

        #region *** SystemWebConfigurationIntrospectionRule ***
        protected override ProblemCollection Check(SystemWebSectionGroup webConfig)
        {
            if (webConfig == null)
                throw (new ArgumentNullException("webConfig"));

            if (webConfig.RoleManager.Enabled)
            {
                if (webConfig.RoleManager.CookieProtection != CookieProtection.All)
                    AddProblem(webConfig.RoleManager.ElementInformation);
            }

            return base.Problems;
        }
        #endregion
    }
}