﻿//****************************************************************************
// Copyright (c) Microsoft Corporation. All rights reserved.
//****************************************************************************
using System;
using System.Configuration;
using System.Web.Configuration;
using System.Web.Security;
using System.Diagnostics.CodeAnalysis;

using Microsoft.FxCop.Sdk;

namespace Microsoft.FxCop.Rules.ASP.Security.Configuration
{
    sealed class RoleManagerCookieRequireSSLShouldBeTrue : SystemWebConfigurationIntrospectionRule
    {

        #region *** Constructor ***
        public RoleManagerCookieRequireSSLShouldBeTrue()
            : base(typeof(RoleManagerCookieRequireSSLShouldBeTrue).Name)
        {
        }
        #endregion

        #region *** SystemWebConfigurationIntrospectionRule **
        protected override ProblemCollection Check(SystemWebSectionGroup webConfig)
        {
            if (webConfig == null)
                throw (new ArgumentNullException("webConfig"));

            if (webConfig.RoleManager.Enabled)
            {
                if (!webConfig.RoleManager.CookieRequireSSL)
                    AddProblem(webConfig.RoleManager.ElementInformation);
            }

            return base.Problems;
        }
        #endregion
    }
}