﻿//****************************************************************************
// Copyright (c) Microsoft Corporation. All rights reserved.
//****************************************************************************
using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.FxCop.Sdk;
using System.Reflection;

namespace Microsoft.FxCop.Rules.ASP.Security.Configuration
{
    /// <summary>
    /// Base introspection rule class.
    /// </summary>
    public abstract class SemanticIntrospectionRule : BaseIntrospectionRule
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="T:SemanticIntrospectionRule"/> class.
        /// </summary>
        /// <param name="name">The name.</param>
        protected SemanticIntrospectionRule(string name, string resourceName)
            : base(name, resourceName, typeof(SemanticIntrospectionRule).Assembly)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="T:SemanticIntrospectionRule"/> class.
        /// </summary>
        /// <param name="name">The name.</param>
        /// <param name="resourceName">Name of the resource.</param>
        /// <param name="resourceAssembly">The resource assembly.</param>
        protected SemanticIntrospectionRule(string name, string resourceName, Assembly resourceAssembly)
            : base(name, resourceName, resourceAssembly)
        {
        }

        /// <summary>
        /// Gets the target visibility.
        /// </summary>
        /// <value>The target visibility.</value>
        public override TargetVisibilities TargetVisibility
        {
            get { return (TargetVisibilities.All); }
        }
    }
}
